let pos_pts = [|
  [| -1; -1; -1; -1; -1; -1; -1; -1; -1; -1 |];
  [| -1; 10; -3; 1; 1; 1; 1; -3; 10; -1 |];
  [| -1; -3; -5; 0; 0; 0; 0; -5; -3; -1 |];
  [| -1; 1; 0; 0; 0; 0; 0; 0; 1; -1 |];
  [| -1; 1; 0; 0; 0; 0; 0; 0; 1; -1 |];
  [| -1; 1; 0; 0; 0; 0; 0; 0; 1; -1 |];
  [| -1; 1; 0; 0; 0; 0; 0; 0; 1; -1 |];
  [| -1; -3; -5; 0; 0; 0; 0; -5; -3; -1 |];
  [| -1; 10; -3; 1; 1; 1; 1; -3; 10; -1 |];
  [| -1; -1; -1; -1; -1; -1; -1; -1; -1; -1 |];
|]

let eval c t =
  let e = (3 - c) in
  let pos_pt = Board.accum t (
    fun x y v a ->
      if (v == c) then
        a + (pos_pts.(x).(y))
      else
        if (v == e) then
          a - (pos_pts.(x).(y))
        else
          a
  ) 0 in
  let put_pt = Board.can_put_num_diff t c in
    pos_pt + put_pt

let think search d t c =
  let first = Sys.time() in
  let ret = search t c d (eval c) in
  let elapsed = Sys.time() -. first in
(*
    if (elapsed < 0.5) then (
      print_string "in depth...\n";
      search t c (d+1) (eval c)
    )
    else
*)
      ret
