(* generic depth first search *)

let rec search_impl t c depth eval side =
  if (depth == 0) then
    ((eval t), 0, 0, 1)
  else
    Board.accum t (
      fun x y v a ->
        if (Board.can_put t c x y) then
          let _ = Board.put t c x y in
          let nt = t + 1 in
          let nc = 3 - c in
          let (av, ax, ay, ac) = a in
          let v =
            if (Board.can_put_all nt nc) then
              search_impl nt nc (depth-1) eval (-side)
            else
              if (Board.can_put_all nt c) then
                search_impl nt c (depth-1) eval side
              else
                ((eval nt), 0, 0, 1)
          in
          let (vv, vx, vy, vc) = v in
          let cnt = vc + ac in
            if (vv*side > av*side) then (vv, x, y, cnt) else (av, ax, ay, cnt)
        else a
    ) (-100*side, 0, 0, 0)

let search t c depth eval =
  let first = Sys.time() in
  let (v, x, y, cnt) = search_impl t c depth eval 1 in
  let elapsed = Sys.time() -. first in
    Printf.printf "%d %d %d %d %f\n" v x y cnt elapsed;
    (x, y)
