(* generic depth first search with cache *)

let invlid = -10000

let cache_b = Array.create (Conf.cache_size*4) invlid
let cache = Array.create Conf.cache_size invlid

let cmod = Conf.cache_size

let hash t =
  let v = Board.accum t (
    fun x y v a ->
      let i = (x + y * 8 - 9) lsr 4 in
        a.(i) <- a.(i) * 3 + v;
        a
  ) [| 0; 0; 0; 0 |] in
  (v, (v.(0) lxor (v.(1) lsl 1) lxor (v.(2) lsl 3) lxor (v.(3) lsl 4)) mod cmod)

let rec search_impl t c depth eval side =
  if (depth == 0) then
    ((eval t), 0, 0, 1)
  else
    Board.accum t (
      fun x y v a ->
        if (Board.can_put t c x y) then
          let _ = Board.put t c x y in
          let nt = t + 1 in
          let nc = 3 - c in
          let (av, ax, ay, ac) = a in
          let (lhash, hash) = hash nt in
(* Printf.printf "%d %d\n" lhash hash; *)
          let h4 = hash*4 in
(* Printf.printf "%d\n" h4;  *)
          let cvalue = cache.(hash) in
          let v =
            if (cvalue != invlid && cache_b.(h4) == lhash.(0) && cache_b.(h4+1) == lhash.(1) && cache_b.(h4+2) == lhash.(2) && cache_b.(h4+3) == lhash.(3)) then
              (cvalue, 0, 0, 0)
            else
              if (Board.can_put_all nt nc) then
                search_impl nt nc (depth-1) eval (-side)
              else
                if (Board.can_put_all nt c) then
                  search_impl nt c (depth-1) eval side
                else
                  ((eval nt), 0, 0, 1)
          in
          let (vv, vx, vy, vc) = v in
            cache_b.(h4) <- lhash.(0);
            cache_b.(h4+1) <- lhash.(1);
            cache_b.(h4+2) <- lhash.(2);
            cache_b.(h4+3) <- lhash.(3);
            cache.(hash) <- vv;
            let cnt = vc + ac in
              if (vv*side > av*side) then (vv, x, y, cnt) else (av, ax, ay, cnt)
        else a
    ) (-100*side, 0, 0, 0)

let search t c depth eval =
  Array.fill cache 0 Conf.cache_size invlid;
  let first = Sys.time() in
  let (v, x, y, cnt) = search_impl t c depth eval 1 in
  let elapsed = Sys.time() -. first in
    Printf.printf "%d %d %d %d %f\n" v x y cnt elapsed;
    (x, y)
