let _ =
  Gui.init;

  let irc = (stdin, stdout) in
(*  let irc = if (Conf.use_irc) then Irc.init() else (stdin, stdout) in *)

  let algos = [|
    (fun t c -> raise (Failure "assert"));
    Gui.think;
    CpuRevolver.think DfCache.search DfCache.search 5 11;
    CpuRevolver.think DfCache.search DfCache.search 5 11;
    CpuRevolver.think Df.search Df.search 5 11;
    CpuRevolver.think Df.search Df.search 5 11;
(*    Irc.think_sugar_ai irc; *)
    CpuRevolver.think Df.search Df.search 3 10;
    Gui.think;
(*    CpuRevolver.think Df.search Df.search 3 10; *)
  |] in

  let reports = [|
    (fun c x y -> raise (Failure "assert"));
    (fun c x y -> ());
    (fun c x y -> ());
(*    Irc.report_sugar_bot irc; *)
  |] in

    if (Conf.player1#get = "human") then
      algos.(1) <- Gui.think
    else
      if (Conf.player1#get = "cpu") then
        algos.(1) <- (CpuRevolver.think DfCache.search DfCache.search
                        Conf.cpu1middle#get Conf.cpu1last#get);
    if (Conf.player2#get = "human") then
      algos.(2) <- Gui.think
    else
      if (Conf.player2#get = "cpu") then
        algos.(2) <- (CpuRevolver.think DfCache.search DfCache.search
                        Conf.cpu2middle#get Conf.cpu2last#get);

  let rec game_main turn color =
    Board.info turn;
    Gui.draw turn;
    let (x, y) = algos.(color) turn color in
      reports.(color) color x y;
      let _ = Board.put turn color x y in
      let nt = turn + 1 in
      let nc = 3 - color in
        if (Board.can_put_all nt nc) then
          game_main nt nc
        else
          if (Board.can_put_all nt color) then
            game_main nt color
          else
            nt
  in
  let eturn = game_main 0 1 in
    Board.info eturn;
    Gui.draw eturn;
    Gui.last_wait ()
