let init =
  Graphics.open_graph " 400x400";

    print_string "graphics inited\n"

let draw t =
  Graphics.clear_graph ();

  Graphics.set_color 0x109010;
  Graphics.fill_rect 0 0 400 400;

  Graphics.set_color 0xffffff;
  let rec run_x x =
    if (x <= 8) then (
      Graphics.draw_poly_line [| (40+x*40,40); (40+x*40,360) |];
      run_x (x+1)
    )
  in
    run_x 0;
  let rec run_y y =
    if (y <= 8) then (
      Graphics.draw_poly_line [| (40,40+y*40); (360,40+y*40) |];
      run_y (y+1)
    )
  in
    run_y 0;

  Board.each t (
    fun x y v ->
      if (v != 0) then (
        Graphics.set_color (if (v == 1) then 0x000000 else 0xffffff);
        Graphics.fill_circle (20+x*40) (380-y*40) 16
      )
  );
  Graphics.moveto 0 0;
  Graphics.set_color 0xffffff;
  if (Sys.os_type = "Win32") then
    Graphics.set_font "arial";
  Graphics.draw_string ("B " ^ (string_of_int (Board.num t 1)));
  Graphics.draw_string (" W " ^ (string_of_int (Board.num t 2)))

let think t c =
  let rec wait_start () =
    let e = Graphics.wait_next_event [Graphics.Button_down] in
    let (mx, my) = Graphics.mouse_pos () in
(*
    let mx = e.mouse_x in
    let my = e.mouse_y in
*)
    let x = mx / 40 in
    let y = (400 - my) / 40 in
      if (x >= 1 && x <= 8 && y >= 1 && y <= 8 && Board.can_put t c x y) then
        (x, y)
      else
        wait_start ()
  in
    wait_start ()

let last_wait () =
  let _ = Graphics.wait_next_event [Graphics.Button_up] in
  let _ = Graphics.wait_next_event [Graphics.Button_down] in
    ()

